Description

It should be possible to get the Python stack trace for gammalib Python unit tests.

This has been dicussed in issue #616.

Ideally there would be a "debug mode" where the developer gets the traceback on the console and can also add print statements to

the code that will show up un the console.

But also for unit tests running on Jenkins it is important to have the stack trace, otherwise it will be impossible to tell for developers

why a given test failed on some machine / environment they might not have access to after their commit.

I'm sure it is possible to make this work with the current gammalib unit test framework, but for the record, my suggestion would be to

use the Python standard library unit test instead and not spend time reproducing this functionality (e.g. more assert statements, test

discovery i.e. not having to list tests explicitly, useful verbosity levels, decorators for slow tests, ...). Another advantage is that every

Python developer knows it, whereas at the moment I and any other developer has to learn the gammalib unit test framework.

History

#1 - 12/06/2012 01:00 AM - Knödlseder Jürgen

Just a note: don't use print in Python code, as the command is obsolete in Python 3! We want to keep GammaLib compatible with Python3 ...

#2 - 12/06/2012 09:32 AM - Deil Christoph

Jürgen Knödlseder wrote:

Just a note: don't use print in Python code, as the command is obsolete in Python 3! We want to keep GammaLib compatible with Python3 ...

 

If you use print('hi') instead of print 'hi' it will work with any Python 2 and Python 3:

http://docs.python.org/3.0/whatsnew/3.0.html#print-is-a-function

I don't see a reason to use the more cumbersome import sys; sys.stdout.write() all the time.

#3 - 12/06/2012 09:49 AM - Deil Christoph

Concretely, the assert I wanted for the coords_check was assertLess(first, second, msg=None):

http://docs.python.org/2/library/unittest.html#unittest.TestCase.assertLessEqual

So if there is some architecture where the test fails I would get the values of first and second in the log and I'd more quickly have an idea what is

going on.
#4 - 12/06/2012 12:37 PM - Knödlseder Jürgen

Christoph Deil wrote:

Jürgen Knödlseder wrote:

Just a note: don't use print in Python code, as the command is obsolete in Python 3! We want to keep GammaLib compatible with Python3

...

 

If you use print('hi') instead of print 'hi' it will work with any Python 2 and Python 3:

http://docs.python.org/3.0/whatsnew/3.0.html#print-is-a-function

I don't see a reason to use the more cumbersome import sys; sys.stdout.write() all the time.

 

Does print('hi') work for all Python 2 versions? If this is the case, I have no problem with using simply print('hi'). We should add a note about this in the

coding standard document.

#5 - 12/06/2012 12:38 PM - Knödlseder Jürgen

Christoph Deil wrote:

Concretely, the assert I wanted for the coords_check was assertLess(first, second, msg=None):

http://docs.python.org/2/library/unittest.html#unittest.TestCase.assertLessEqual

So if there is some architecture where the test fails I would get the values of first and second in the log and I'd more quickly have an idea what is

going on.

 

We can add this feature, just create an issue.

#6 - 12/21/2012 12:43 AM - Knödlseder Jürgen

- Target version set to 00-08-00

#7 - 03/23/2013 02:54 AM - Knödlseder Jürgen
Here an interesting link:

http://stackoverflow.com/questions/1796510/accessing-a-python-traceback-from-the-c-api

#8 - 12/10/2013 12:18 AM - Knödlseder Jürgen

- Target version deleted (00-08-00)
